/*****************************************************************************
 *   Placeholder for GPS functions.
 *   Part of the proposed solutions for LPCXpresso Experiment Kit
 *
 *   Copyright(C) 2013, Embedded Artists AB
 *   All rights reserved.
 *
 ******************************************************************************/
#ifndef __GPS_H__
#define __GPS_H__

#include "type.h"

/**
 * Data structure for the GPS values
 */
typedef struct gpsData {
	uint8_t satellitesUsed[20];
	uint8_t utcTime[20];
	uint8_t altitude[20];
	uint8_t bufLatitude[20];
	uint8_t bufLongitude[20];
	int positionFixed;
	int northSouthIndicator;
	int eastWestIndicator;
	int latitude;
	int longitude;
} gpsData;

/*****************************************************************************
 ** Function name:               GPSRetreiveData
 **
 ** Descriptions:                Reads and parses the next set of GPS data.
 **
 ** parameters:                  None
 ** Returned value:              The parsed information
 **
 *****************************************************************************/
const gpsData* GPSRetreiveData(void);


#endif  /* __GPS_H__ */
